package io.zipcoder;

import java.util.Stack;

public class ParenChecker {

    public boolean matchingCharacters (char char1, char char2){
        if (char1== '(' && char2==')') {
            return true;
        } else if (char1 == '[' && char2 == ']'){
            return true;
        } else if (char1 == '{' && char2 == '}'){
            return true;
        } else if (char1 == '<' && char2 == '>'){
            return true;
        } else if (char1 == '"' && char2 == '"') {
            return true;
//        } else if (char1 == ''')
        } else return false;
    }

    public boolean balancedCharacters(String input, char pair1, char pair2) {
        Stack<Character> stack = new Stack<Character>();
        char[] array = input.toCharArray();


        for (char c : array) {

            if (c == pair1) {

                stack.push(c);
            }
            else if (c == pair2) {
                if(stack.empty()) {
                    return false;
                }

                else if (!matchingCharacters(stack.pop(), c)) {
                    return false;
                }

            }

        }
        if (stack.empty()) {
            return true;
        } else {
            return false;
        }
    }

    private boolean quotationMarks(String input) {
        // Stack<Character> stack = new Stack<Character>();
        char[] array = input.toCharArray();
        boolean paired = false;
        int dblQuote = 0;
        int singleQuote = 0;
        for (char c : array) {
            if(c == '\"') {
                dblQuote++;
            } else if (c == '\''){
                singleQuote++;
            }

        }
        if (dblQuote % 2 == 0 && singleQuote % 2 == 0)
            paired = true;


        return paired;

    }



    boolean completeCheck(String input) {




        boolean parenth = balancedCharacters(input, '(', ')');
        boolean square = balancedCharacters(input, '[', ']');
        boolean curly = balancedCharacters(input, '{', '}');
        boolean angle = balancedCharacters(input, '<', '>');
        boolean quotes = quotationMarks(input);

        return (parenth && square && curly && angle && quotes);
    }
}
